// Criterion.mqh
//         MQL4.
//--------------------------------------------------------------- 1 --
//    .
//  :
// 10 -  Buy  
// 20 -  Sell 
// 11 -  Buy
// 21 -  Sell
// 0  -   
// -1 -    
//--------------------------------------------------------------- 2 --
//  :
  //--------------------------------------------------------------- 3 --
int Criterion()                            //  
 {
   string Sym=Symbol();
   double
   ADX0_0, ADX0_1,                         //  ADX0  0  1 
   ADX1_0, ADX1_1,                         //  +DI  0  1 
   ADX2_0, ADX2_1,                         //  -DI  0  1 
   AO_0, AO_1,                             //  AO  0  1 
   St_M_0, St_M_1,                         //  MAIN  0  1 
   St_S_0, St_S_1;                         //  SIGNAL  0  1 
//--------------------------------------------------------------- 4 --
   //  . :
   ADX0_0=iADX(NULL, 0, 13, PRICE_CLOSE, MODE_MAIN, 0);                                   // 0 
   ADX0_1=iADX(NULL, 0, 13, PRICE_CLOSE, MODE_MAIN, 1);                                   // 1 
   ADX1_0=iADX(NULL, 0, 13, PRICE_CLOSE, MODE_PLUSDI, 0);                                 // 0 
   ADX1_1=iADX(NULL, 0, 13, PRICE_CLOSE, MODE_PLUSDI, 1);                                 // 1 
   ADX2_0=iADX(NULL, 0, 13, PRICE_CLOSE, MODE_MINUSDI, 0);                                // 0 
   ADX2_1=iADX(NULL, 0, 13, PRICE_CLOSE, MODE_MINUSDI, 1);                                // 1 
   
   AO_0=iMA(NULL,0,5,0,MODE_SMA,PRICE_MEDIAN,0)-iMA(NULL,0,34,0,MODE_SMA,PRICE_MEDIAN,0);  //0 
   AO_1=iMA(NULL,0,5,0,MODE_SMA,PRICE_MEDIAN,1)-iMA(NULL,0,34,0,MODE_SMA,PRICE_MEDIAN,1);  //1 

   St_M_0=iStochastic(NULL,PERIOD_M15,14,6,4,MODE_SMA,0,MODE_MAIN,0);                     // MAIN  0 ;
   St_M_1=iStochastic(NULL,PERIOD_M15,14,6,4,MODE_SMA,0,MODE_MAIN,1);                     // MAIN  1 
   St_S_0=iStochastic(NULL,PERIOD_M15,14,6,4,MODE_SMA,0,MODE_MAIN,0);                     // SIGNAL  0 ;
   St_S_1=iStochastic(NULL,PERIOD_M15,14,6,4,MODE_SMA,0,MODE_MAIN,1);                     // SIGNAL  1 ;
//--------------------------------------------------------------- 5 --
   //   
   if(ADX0_0>ADX0_1 && ADX1_0>ADX2_0 && AO_0>AO_1 && St_M_0>St_S_0)
      return(10);                      //  Buy    
   if(ADX0_0>ADX0_1 && ADX1_0<ADX2_0 && AO_0<AO_1 && St_M_0<St_S_0)
      return(20);                      //  Sell 
   if(ADX0_0<ADX0_1 && AO_0<AO_1)
      return(11);                      //  Buy    
   if(ADX0_0<ADX0_1 && AO_0>AO_1)
      return(21);                      //  Sell         
//--------------------------------------------------------------- 6 --
   return(0);                          //   . 
  }
//--------------------------------------------------------------- 7 --