//--------------------------------------------------------------------
// Lot.mqh
//         MQL4.
//--------------------------------------------------------------- 1 --
//    .
//  :
// double Lots_New -      ()
// double Lots     -   ,  .
// int Percent     -  ,  
//  :
// true  -      
// false -       
//--------------------------------------------------------------- 2 --
bool Lot()                                     //  -
  {
   string Symb   =Symbol();                    //  .
   double One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//. 1 
   double Min_Lot=MarketInfo(Symb,MODE_MINLOT);// . . 
   double Step   =MarketInfo(Symb,MODE_LOTSTEP);//  
   double Free   =AccountFreeMargin();         //  
//--------------------------------------------------------------- 3 --
   if (Lots>0)                                 //   ..
     {                                         // .. 
      double Money=Lots*One_Lot;               //  
      if(Money<=AccountFreeMargin())           //  ..
         Lots_New=Lots;                        // .. 
      else                                     //   ..
         Lots_New=MathFloor(Free/One_Lot/Step)*Step;//  
     }
//--------------------------------------------------------------- 4 --
   else                                        //    
     {                                         // ..  
      if (Percent > 100)                       //   ..
         Percent=100;                          // ..    100
      if (Percent==0)                          //   0 ..
         Lots_New=Min_Lot;                     // ..  
      else                                     // . .:
         Lots_New=MathFloor(Free*Percent/100/One_Lot/Step)*Step;//
     }
//--------------------------------------------------------------- 5 --
   if (Lots_New < Min_Lot)                     //   ..
      Lots_New=Min_Lot;                        // ..  
   if (Lots_New*One_Lot > AccountFreeMargin()) //   ..
     {                                         // .. . :(
      Inform(11,0,Min_Lot);                    // ..
      return(false);                           // ..  
     }
   return(true);                               //   . -
  }
//--------------------------------------------------------------- 6 --
